#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>

struct arguments {
  long int *array;
  long int size;
  long int *sum;
};
  
#define ARRAY_SIZE 1234567
void *do_work(void *);

int main(void) {
  long int array[ARRAY_SIZE];
  long int sum;
  pthread_t worker_thread;
  struct arguments *arg;
  long int i;

  for(i=0;i<ARRAY_SIZE;i++)
      array[i]=1;
  
  arg = calloc(1,sizeof(struct arguments));
  arg->array = array; 
  arg->size=ARRAY_SIZE; 
  arg->sum = &sum;
  
  if (pthread_create(&worker_thread, NULL, do_work, (void *)arg)) 
    {
      fprintf(stderr,"Error while creating thread\n");
      exit(1);
    }

  printf("Main is doing something else...\n");
  while(i<2000000000)
    i++;

  printf("Wait for thread to finish...\n");
  
  if(pthread_join(worker_thread, NULL)) {
    fprintf(stderr,"Error while waiting for thread\n");
    exit(1);
  }

  printf("Result: %d\n",sum);
  exit(0);
}

void *do_work(void *arg)
 {
 struct arguments *argument;
 long int i, size;
 long int *array;
 long int *sum;

 argument = arg;
 
 size = argument->size;
 array = argument->array;
 sum = argument->sum;

 printf("Thread started computation...\n");
 
 *sum = 0;
 for (i=0;i<size;i++)
    *sum += array[i];  

 while(i<10000000000)
    i++;

printf("Thread finished computation...\n");

return NULL;
}
